> For the complete documentation index, see [llms.txt](https://docs.feathery.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.feathery.io/develop/react/api-guide/form/custom-jsx-components.md).

# Custom JSX Components

Embed custom JSX components into your Feathery form.

### Overview

Include custom JSX components in your [Feathery form](/develop/react/api-guide/form.md) by passing them as part of the `customComponents` prop or directly as React `children`. You can [add custom HTML, JS, and iframes](/platform/build-forms/elements/custom-html-js-css-and-iframes.md) directly from the editor.

#### customComponents

Pass your JSX components as a mapping to the `customComponents` prop if you'd like them to be placed in specific [containers](/platform/build-forms/elements/basic/container.md) on specific steps. The key of the mapping is the container ID, and the value is the component itself. If the specified container exists, your component will be **appended** to any children that already exists within it.

```
import { init, Form } from '@feathery/react';

function App() {
  // Initialize Feathery
  init('SDKKey', 'support@feathery.io');

  // Show the `aBcDeF` Feathery form
  return (
    <Form 
      formId='aBcDeF'
      customComponents={{ 'container-id': <MyAnimation /> }}
    />
  );
}
```

#### children <a href="#usage" id="usage"></a>

Pass your components as `children` if you'd like them to be absolutely positioned and available across every step. You might want to inject custom components like animations, dynamic data, and more.

```
import { init, Form } from '@feathery/react';

function App() {
  // Initialize Feathery
  init('SDKKey', 'support@feathery.io');

  // Show the `aBcDeF` Feathery form
  return (
    <Form formId='aBcDeF'>
      <MyAnimation />
    </Form>
  );
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.feathery.io/develop/react/api-guide/form/custom-jsx-components.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
